/* Structures and some other things in this file were taken from
   "spc2wav.c".
*/

#include        <stdio.h>
#include        <stdlib.h>
#include	<string.h>
#include        "Types.h"
#include        "SPC700.h"
#include        "DSP.h"
#include        "APU.h"
#include	"spcload.h"
#include	"config.h"

void KillSPC(SPCINFO *info)
{
 //free(info->pAPUBase);
}

void LoadID666Ex(FILE *fp, SPCINFO *info)
{
 int id;
 u32 intro=~0,loop=~0,end=~0,loopx=1;
 u32 scount=0;
 u32 size;
 u8 verify[4]={'x','i','d','6'};
 u8 bv[4];

 fseek(fp,66048,SEEK_SET);
 fread(bv,1,4,fp);
 if(memcmp(bv,verify,4)) return;	// Not valid...
 fread(&size,1,4,fp);

 while((id=fgetc(fp))>=0 && scount<size)
 {
  int type=fgetc(fp);
  scount++;

  if(type)	//
  {
   unsigned int len;
   char buf[256];

   len=fgetc(fp);
   len|=fgetc(fp)<<8;
   scount+=2;
   if(len<=256)
   {
    fread(buf,1,len,fp);
    buf[255]=0;
    //printf("%02x %08x %s\n",id,*(u32*)buf,buf);
    switch(id)
    {
     case 0x01:strcpy(info->song,buf);break;
     case 0x02:strcpy(info->game,buf);break;
     case 0x03:strcpy(info->artist,buf);break;
     case 0x04:strcpy(info->dumper,buf);break;
     case 0x05:strcpy(info->comments,buf);break;
     case 0x30:intro=*(u32*)buf;break;
     case 0x31:loop=*(u32*)buf;break;
     case 0x32:end+=*(u32*)buf;break;
     case 0x33:info->fade=*(u32*)buf;break;	// Fade length.
     case 0x35:loopx=*(u32*)buf;break;
    }
   }
   else
    fseek(fp,len,SEEK_CUR);
   scount+=len;
  }
  else
  {
   char data[2]; 
   data[0]=fgetc(fp);
   data[1]=fgetc(fp);
   scount+=2;
   switch(id)
   {
    case 0x06:break;	// Emulator
    case 0x11:break;	// OST disc
    case 0x12:break;	// OST track
    case 0x14:break;	// Copyright year.  I'm guessing since 1900?  I could've
			// gone for some SNES fun during the great depression...
    case 0x34:break;	// Muted channels.  Go away.
   }
  }
 }
 if((intro!=~0) || (loop!=~0) || (end!=~0))
 {
  if(intro==~0) intro=0;
  if(loop==~0) loop=0;
  if(end==~0) end=0;
  info->length=intro+loop*loopx+end;
 }
}

int LoadID666(FILE *fp, SPCINFO *info)
{
	u8 buf[0x100 - 0x2E];
	u8 *ib=buf;
	int isbinary = 1;

	fread(buf,1,0x100 - 0x2E,fp);

	memcpy(info->song,ib,32);
	info->song[31]=0;
	ib+=32;

	memcpy(info->game,ib,32);
	info->game[31]=0;
	ib+=32;

	memcpy(info->dumper,ib,16);
	info->dumper[15]=0;
	ib+=16;

	memcpy(info->comments,ib,32);
	info->comments[31]=0;
	ib+=32;

	/* Ok, now comes the fun part. */

	/* Date check */
	if(ib[2] == '/'  && ib[5] == '/' )
	 isbinary = 0;

	/* Reserved bytes check */
	if(ib[0xD2 - 0x2E - 112] >= '0' && ib[0xD2 - 0x2E - 112] <= '9' && ib[0xD3 - 0x2E - 112] == 0x00)
	 isbinary = 0;
	//printf("%02x\n",ib[0xD2 - 0x2E - 112]);

	//printf("%d\n", isbinary);

	if(isbinary)
	{
	 info->year=*ib;
	 ib++;
	 info->year|=*ib<<8;
	 ib++;
	 info->month=*ib;
	 ib++;	 
	 info->day=*ib;
	 ib++;

	 ib+=7;

	 info->length=*ib;
 	 ib++;

	 info->length|=*ib<<8;
	 ib++;

	 info->length|=*ib<<16;
	 info->length*=64000;
	 ib++;

	 info->fade=*ib;
	 ib++;
	 info->fade|=*ib<<8; 
         ib++;
         info->fade|=*ib<<16;
         ib++;
	 info->fade|=*ib<<24;
	 info->fade*=64;
	 ib++;
	}
	else
	{
	 int year, month, day;
	 int tmp;
	 char buf[64];

	 year=month=day=0;
	 ib[10]	= 0;
	 sscanf(ib, "%02d/%02d/%04d", &month, &day, &year);
	 info->year = year;
	 info->day = day;
	 info->month = month;
	 
	 ib+=11;
	
	 memcpy(buf, ib, 3);
	 buf[3] = 0;	
	 tmp = 0;
	 sscanf(buf, "%d", &tmp);
	 info->length = tmp * 64000;

	 memcpy(buf, ib, 5);
	 buf[5] = 0;
	 tmp = 0;
	 sscanf(buf, "%d", &tmp);
	 info->fade = tmp * 64;
	}
	return 1;
}

void SetSPC(SPCINFO *info, void *pAPURAM)
{
 SPCReg *pReg;

 ResetAPU(0x10000);
 SetAPUOpt(MIX_INT,SexyConfig.channels,SexyConfig.bits,
	SexyConfig.rate,SexyConfig.interpolation,SexyConfig.dspoptions);

 //LoadSPCFile((void *)&info->spcData);
 memcpy(pAPURAM, info->spcData.APURAM,65536);
 memcpy(&dsp,info->spcData.dsp,128);
 memcpy(&extraRAM,info->spcData.extraRAM,64);
  
 pReg = &(info->spcHdr.reg);
 FixAPU(*(u16*)pReg->pc, pReg->a, pReg->y, pReg->x,pReg->psw, pReg->sp);

 if(info->length)
  SetAPULength(info->length,info->fade);
}

int LoadSPC(char *fn, SPCINFO *info, void *pAPURAM)
{
 FILE *fp;

 if(!(fp=fopen(fn,"rb"))) return(0);

 memset(info,0,sizeof(SPCINFO));

 fread(&(info->spcHdr), 1, sizeof(SPCHdr), fp);
 LoadID666(fp,info);
 if(pAPURAM)
 {
  fread(&(info->spcData), 1, sizeof(SPCData), fp);
 }

 LoadID666Ex(fp,info);
 fclose(fp);

 if(!info->game[0])
 {
  char *begin,*end;
  int len;

  begin=end=0;
  begin=strrchr(fn,'/');
  end=strrchr(fn,'.');
  if(!begin) begin=fn;
  else begin++;
  if(end)
   len=end-begin;
  else
   len=strlen(fn)-(begin-fn);

  if(len>255) len=255;
  info->song[0]=0;
  strncpy(info->game,begin,len);
  info->game[len]=0;
 }

 info->totallength=info->length+info->fade;
 if(!info->totallength) info->totallength=(99*60+59)*64000;

 if(pAPURAM)
  SetSPC(info, pAPURAM);

 return(1);
}
